config/routes.rb
Rails.application.routes.draw do
  resources :categories
  devise_for :users
  resources :articles do
    resources :comments, only: [:create, :update, :destroy, :show]
  end
=begin
    get: '/articles' index
    post: '/articles' create
    delete: '/articles/:id' destroy
    get: '/articles/:id' show
    get: '/articles/new'
    get: '/articles/:id/edit' edit
    patch: '/articles/:id' update
    put: '/articles/:id' update
=end

   root 'welcome#index'

end

app/models/comment.rb
class Comment < ActiveRecord::Base
  belongs_to :user
  belongs_to :article
end

app/controllers/comments_controller.rb
class CommentsController < ApplicationController
  before_action :set_comment, only: [:update, :destroy,:show]
  before_action :set_article
  before_action :authenticate_user!
  # GET /comments
  # GET /comments.json

  # POST /comments
  # POST /comments.json
  def show
  end
  def create
#desde el usuario logueado accedo a has_many :coments y le paso los parametros
#que serian el id del usario logueado, el articulo que esta por url y el cuerpo
#del comentario que se envia por form
    @comment = current_user.comments.new(comment_params)
    @comment.article = @article
    respond_to do |format|
      if @comment.save
        format.html { redirect_to @comment.article, notice: 'Se creo correctamente el comentario.' }
        format.json { render :show, status: :created, location: @comment.article }
      else
        format.html { render :new }
        format.json { render json: @comment.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /comments/1
  # PATCH/PUT /comments/1.json
  def edit
  end
  def update
    @article = Article.find(params[:article_id])
    @comment = @article.comments.find(params[:id])
    if @comment.save
        redirect_to article_path(@article)
    else
      render :edit
    end
  end

  # DELETE /comments/1
  # DELETE /comments/1.json
  def destroy
    @article = Article.find(params[:article_id])
    @comment = @article.comments.find(params[:id])
    @comment.destroy
    respond_to do |format|
      format.html { redirect_to article_path(@article), notice: 'El comentario fue eliminado con exito.' }
      format.json { head :no_content }
    end
  end

  private
    def set_article
      @article = Article.find(params[:article_id]) #obtengo el id del articulo al cual pertenece el comment
    end
    # Use callbacks to share common setup or constraints between actions.
    def set_comment
      @comment = Comment.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def comment_params
      #solicito la tabla comment y le asigno el hash enviado por post del form
      #donde cada parametro envio por el hash coinsiden con los de la tabla
      params.require(:comment).permit(:user_id, :article_id, :body)
    end
    def update_params
      params.require(:comment).permit(:body)
    end
end

app/helpers/comments_helper.rb
module CommentsHelper
end

app/views/comments/_form.html.erb
  <%= form_for([@article, @comment], remote: true, html:{id: "comments-form", :"data-type" => "json"}) do |f| %>
    <% if @comment.errors.any? %>
      <div id="error_explanation">
        <h2><%= pluralize(@comment.errors.count, "error") %> prohibited this comment from being saved:</h2>

        <ul>
        <% @comment.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
        </ul>
      </div>
    <% end %>

    <div class="form-group">
      <%= f.label :body, 'Comentario' %><br>
      <%= f.text_area :body, class:'form-control'%>
    </div>
    <div class="actions">
      <%= f.submit('Enviar Comentario', class: "btn btn-success")%>
    </div>
  <% end %>

app/views/comments/edit.html.erb
<h1 class="text-center">Editar Comentario</h1>

<div class="container">
  <%= render 'form' %>
  <%= link_to 'Show', @comment %> |
  <%= link_to 'Back', comments_path %>
</div>

app/views/comments/new.html.erb
<h1 class="text-center">Nuevo Comentario</h1>
<div class="container">
  <%= render 'form' %>
  <%= link_to 'Volver', comments_path %>
</div>

app/views/comments/show.html.erb
<div class="container">
  <p id="notice"><%= notice %></p>
  <p>
    <strong>Usuario:</strong>
    <%= @comment.user %>
  </p>

  <p>
    <strong>Articulo:</strong>
    <%= @comment.article %>
  </p>

  <p>
    <%= @comment.body %>
  </p>

  <%= link_to 'Edit', edit_comment_path(@comment) %> |
  <%= link_to 'Back', comments_path %>
</div>